package test

import java.util.Map
import java.util.List

@Data
class Tag {
	val String name
	val Map<String, String> attributes
	val List<Tag> tags
}

class TemplateTest2 {
	def static void main(String[] args) {
		val html = new Tag("html", newHashMap("xmlns" -> "http://www.w3.org/1999/xhtml"),
			newArrayList(
				new Tag("body", null, newArrayList(
					new Tag("div", newHashMap("id" -> "main_menu", "class" -> "menu"), null),
					new Tag("h1", newHashMap("class" -> "active"), null),
					new Tag("p", null, null)
				))
			))
		
		print(printTag(html))
	}

	def static printTag(Tag tag) {'''
		<«tag.name»«tag.attributes?.entrySet?.join(" ", " ", "", ['''«key»="«value»"'''])»>
			«FOR t : tag.tags ?: newArrayList»
				«printTag(t)»
			«ENDFOR»
		</«tag.name»>
	'''}	
}