package test;

import java.util.List;
import java.util.Map;
import org.eclipse.xtend.lib.Data;
import org.eclipse.xtext.xbase.lib.util.ToStringHelper;

@Data
@SuppressWarnings("all")
public class Tag {
  private final String _name;
  
  public String getName() {
    return this._name;
  }
  
  private final Map<String,String> _attributes;
  
  public Map<String,String> getAttributes() {
    return this._attributes;
  }
  
  private final List<Tag> _tags;
  
  public List<Tag> getTags() {
    return this._tags;
  }
  
  public Tag(final String name, final Map<String,String> attributes, final List<Tag> tags) {
    super();
    this._name = name;
    this._attributes = attributes;
    this._tags = tags;
  }
  
  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((_name== null) ? 0 : _name.hashCode());
    result = prime * result + ((_attributes== null) ? 0 : _attributes.hashCode());
    result = prime * result + ((_tags== null) ? 0 : _tags.hashCode());
    return result;
  }
  
  @Override
  public boolean equals(final Object obj) {
    if (this == obj)
      return true;
    if (obj == null)
      return false;
    if (getClass() != obj.getClass())
      return false;
    Tag other = (Tag) obj;
    if (_name == null) {
      if (other._name != null)
        return false;
    } else if (!_name.equals(other._name))
      return false;
    if (_attributes == null) {
      if (other._attributes != null)
        return false;
    } else if (!_attributes.equals(other._attributes))
      return false;
    if (_tags == null) {
      if (other._tags != null)
        return false;
    } else if (!_tags.equals(other._tags))
      return false;
    return true;
  }
  
  @Override
  public String toString() {
    String result = new ToStringHelper().toString(this);
    return result;
  }
}
